QGIS Application - Bug report #20233
Issue: Large polygon vector layer stored in Spatial
2018-10-26 11:00 PM - Brett Carlock

Lite db not rendering properly

Status: Closed

Priority: Normal

Assignee:

Category: Data Provider/SpatialLite

Affected QGIS version:3.2.3
Operating System: Win10 x64 Pro Version 1809 (OS Build 182
Pull Request or Patch supplied:

No
No

Regression?:
EasPdi?:
Resolution:

Crashes QGIS or corrupls data:

Copied to github as #: 28054

Description

Issue summary:

Relatively large polygon dataset stored in QGIS-created SpatiallLite database will not draw properly/fully within QGIS. Previewed from

SpatialLite-GUI, it appears fine.
Exported to ESRI Shapefile & displayed/loaded, and the layer draws

fully.

Queries/filters/etc can be done against the SpatialLite layer, though they do not change the display.

For instance, if | filter on STATEFP to 50 (Vermont), it'll not show ANY geometries, since all the ones in Vermont do not draw when it is in

this error state. From this | can conclude that it isn't an issue with the
something else entirely.

number of geometries being loaded/drawn at any given time, but

I've verified the integrity of the database multiple times in SQLite Studio as well as SpatiallLite-GUI, and they report good

consistency/validity.

Screencap of the behavior:
https://www.youtube.com/watch?v=vkAHcdlzz3A

History

#1 - 2018-10-26 11:35 PM - Giovanni Manghi
- Status changed from Open to Feedback

Can you link/attach the dataset?

#2 - 2018-10-26 11:56 PM - Brett Carlock

Giovanni Manghi wrote:

Can you link/attach the dataset?

File size: 104 MB, 7z
https://1drv.ms/u/s!|AVMZEGXuAwQzpelUzr JJ6ubh3RWBw

FWIW, | did not have the issue with partial display of features when | used (Processing Toolbox -> Database -> Package layers) to make a GeoPackage

of the same data.
https://www.youtube.com/watch?v=vkAHcdlzz3A
https://1drv.ms/u/s!AvMZEGXuAwQzpelUzr_JJ6ubh3RWBw

#3 - 2018-10-27 02:36 AM - Nyall Dawson

Maybe an issue with the spatial index in the database - can you recreate this?

#4 - 2018-10-27 06:14 AM - Brett Carlock

Nyall Dawson wrote:

Maybe an issue with the spatial index in the database - can you recreate this?

Yep, I'm an idiot.

| assumed that since the database integrity/vacuum was valid, and geometries were valid, and | could add indexes to the layers that all was good and
healthy.

You were correct: Upon calling the Check Spatial Index function in spatialite-gui against the GEOMETRY object for cousub it warned me about it being

inconsistent and to recover it immediately. | did so, and upon doing so, the layer draws fine in QGIS now.

Is there any way for these management tasks to be brought into the QGIS Database Manager? How about warnings/sanity checks upon load of data from
attached databases?

Or alternatively, | just need to improve my database-Fu so that | would have known to check things like this.

Sorry for the waste of time.

#5 - 2018-10-27 01:38 PM - Saber Razmjooei
- Status changed from Feedback to Closed

Feel free to open a ticket related to the index and warnings.
